﻿//////////////////////////////////////////////
// ExportErrorWrapper.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkScripts
{
	class Environment ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../../../../Dll/DllDefines.h"

// nkScripts
#include <NilkinsScripts/Environments/Functions/Function.h>

/// Class ------------------------------------

namespace nkAstraeus::lua::nkExportWrap
{
	class DLL_ASTRAEUS_EXPORT ExportErrorWrapper final
	{
		private :

			// Constructeur, destructeur
			ExportErrorWrapper () = delete ;
			~ExportErrorWrapper () = delete ;

		public :

			// Environment update
			static void updateEnvironment (nkScripts::Environment* env) ;

			// Callbacks
			static nkScripts::OutputValue getErrorDesc (void* object) ;
			static nkScripts::OutputValue getErrorInfo (void* object) ;
			static nkScripts::OutputValue getIndex (void* object) ;
			static nkScripts::OutputValue isActivated (void* object) ;
	} ;
}