﻿//////////////////////////////////////////////
// TestRunException.h
// 
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkDebug
#include "../../Dll/DllDefines.h"

#include "TestStackLevel.h"

// nkLog
#include <NilkinsMemory/Containers/BufferCast.h>
#include <NilkinsMemory/Containers/BufferView.h>
#include <NilkinsMemory/Containers/String.h>
#include <NilkinsMemory/Containers/StringView.h>

/// Class ------------------------------------

namespace nkDebug
{
	class DLL_NKDEBUG_EXPORT TestRunException final
	{
		private :

			// Attributes
			// Results information
			nkMemory::String _rejectionReason ;
			nkMemory::BufferCast<TestStackLevel> _rejectionStack ;

		public :

			// Functions
			// Constructors
			TestRunException () ;
			TestRunException (const nkMemory::StringView& rejectionReason) ;

			// Getters
			nkMemory::StringView getRejectionReason () const ;
			nkMemory::BufferView<TestStackLevel> getRejectionStack () const ;
	} ;
}