﻿//////////////////////////////////////////////
// ConfigManager.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class ConfigHolder ;
}

/// Includes ---------------------------------

// nkGraphics
#include "../Dll/DllDefines.h"

// Common
#include <nilkinsCommon/Patterns/SingletonClass.h>

/// Class ------------------------------------

namespace nkGraphics
{
	class DLL_GRAPHICS_EXPORT ConfigManager final : public nkCommon::SingletonClass<ConfigManager>
	{
		friend class nkCommon::SingletonClass<ConfigManager> ;

		private :

			// Fonctions
			// Constructeur, destructeur
			ConfigManager () ;
			~ConfigManager () ;

		private :

			// Attributs
			// Notre config
			ConfigHolder* _config ;

		public :
	
			// Getters
			ConfigHolder* getCurrentConfig () const ;

			// Setters
			void setConfig (const ConfigHolder& value) ;
	} ;
}