﻿//////////////////////////////////////////////
// LogManager.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkLog
{
	class Logger ;
}

namespace nkMemory
{
	class StringView ;
}

/// Includes ---------------------------------

// nkResources
#include "../Dll/DllDefines.h"

// Common
#include <nilkinsCommon/Patterns/SingletonClass.h>

/// Class ------------------------------------

namespace nkResources
{
	class DLL_RESOURCES_EXPORT LogManager final : public nkCommon::SingletonClass<LogManager>
	{
		friend class nkCommon::SingletonClass<LogManager> ;

		private :
		
			// Le logger enregistré
			nkLog::Logger* _receiver ;
			
		public :

			// Constructeur, destructeur
			LogManager () ;
			~LogManager () ;

			// Setters
			void setReceiver (nkLog::Logger* receiver) ;

			// Getters
			nkLog::Logger* getReceiver () const ;

			// Log
			void log (const nkMemory::StringView& message, const nkMemory::StringView& className) ;
	} ;
}