﻿//////////////////////////////////////////////
// CursorManager.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkWinUi
{
	class Cursor ;
}

/// Includes ---------------------------------

// nkCommon
#include <nilkinsCommon/Patterns/SingletonClass.h>

// nkMemory
#include <NilkinsMemory/Containers/StringView.h>

// Standards
#include <string>
#include <unordered_map>

/// Class ------------------------------------

namespace nkWinUi
{
	class CursorManager final : public nkCommon::SingletonClass<CursorManager>
	{
		friend class nkCommon::SingletonClass<CursorManager> ;

		private :

			// Attributes
			// Map des curseurs
			std::unordered_map<std::string, Cursor*> _cursors ;

			// Curseur actif
			Cursor* _activeCursor ;

		private :

			// Functions
			// Constructeur, destructeur
			CursorManager () ;
			~CursorManager () ;

		public :

			// Manipulation mémoire
			Cursor* createOrRetrieve (const nkMemory::StringView& name) ;
			Cursor* get (const nkMemory::StringView& name) const ;

			// Activation curseur
			void setActiveCursor (Cursor* cursor) ;
	} ;
}